var api = require("../../utils/api.js");
import { Page } from '../../utils/scan';
import { API_USE_COUPON } from '../../const/apiurl'
import { ACTION_GO_SCAN } from '../../const/actioncmd'
import { ACTION_GET_ACCOUNT } from '../../const/actioncmd'
import { ACTION_DIRECT_PAYMENT } from '../../const/actioncmd'
import { ACTION_CONVERT_COUPON } from '../../const/actioncmd'
import { ACTION_GO_HOME } from '../../const/actioncmd'
import { ACTION_REFUND } from '../../const/actioncmd'
import { ACTION_REFUND_FAILED } from '../../const/actioncmd'
import { ACTION_REFUND_SUCCESS } from '../../const/actioncmd'

Page({
  data: {
    //显示弹窗，>1为显示，2loading 3 result success 4 result failed
    scanDialogDisplay: 0,
    dialogShowType: "",//弹窗类型：如refund
    dialogRemindText: "请扫描兑换码",
    dialogLoadingText: "识别中",
    dialogResultSuccessRemind: "兑换码已识别",
    dialogResultSuccessText: "恭喜您！兑换成功",
    dialogResultFailureRemind: "兑换码未识别",
    dialogResultFailureText: "兑换失败，请稍后重试！",
  },

  onLoad() {

  },

  onShow() {
    let context = this;
    my.ix.onBuddyMessage({
      success: (res) => {
        console.info(`onBuddyMessage success: ${JSON.stringify(res)}`);
        if (res.action == ACTION_GO_SCAN) {
          my.ix.sendBuddyMessage({
            // 填入目标小程序的 AppID
            target: getApp().globalData.backScreenAppId,
            data: {
              action: ACTION_GO_SCAN,
              data: null
            },
            success: (res) => {
              console.info(`sendBuddyMessage success: ${JSON.stringify(res)}`);
              //跳转到扫码页面
              my.reLaunch({
                url: "/pages/scan/scan",
              });
            },
            fail: (res) => {
              console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
            }
          });
        } else if (res.action == ACTION_GET_ACCOUNT) {
          var message = {
            data: getApp().globalData.localAccountInfo,
            action: ACTION_GET_ACCOUNT
          }
          my.ix.sendBuddyMessage({
            // 填入目标小程序的 AppID
            target: getApp().globalData.backScreenAppId,
            data: {
              action: ACTION_GET_ACCOUNT,
              data: message
            },
            success: (res) => {
              console.info(`sendBuddyMessage success: ${JSON.stringify(res)}`);
            },
            fail: (res) => {
              console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
            }
          });

        } else if (res.action == ACTION_DIRECT_PAYMENT) {
          //直接收款
          my.ix.sendBuddyMessage({
            target: getApp().globalData.backScreenAppId,
            data: {
              action: ACTION_DIRECT_PAYMENT,
              data: res.data
            },
            success: (sres) => {
              console.log("通知后屏小程序跳转到结算页面  成功 ===》" + JSON.stringify(sres));
              //去结算页面
              my.reLaunch({
                url: "/pages/balance/balance?totalPrice=" + res.data + "&totalQuantity=0&totalDisc=0",
              });
            },
            fail: (fres) => {
              console.log("通知后屏小程序跳转到结算页面 失败 ===》 " + JSON.stringify(fres));
            }
          })
        } else if (res.action == ACTION_CONVERT_COUPON) {
          //兑换券 
          this.setData({ scanDialogDisplay: res.data })
        } else if (res.action == ACTION_REFUND) {
          //显示弹窗
          context.setData({
            scanDialogDisplay: 1,
            dialogShowType: "refund",
            dialogRemindText: "请扫描订单编码",
            dialogLoadingText: "识别中",
            dialogResultSuccessRemind: "退款成功",
            dialogResultSuccessText: "退款完成！会在1~2个工作日 返还到您的付款账户",
            dialogResultFailureRemind: "退款失败",
            dialogResultFailureText: "退款失败！无效的订单码",
          });

        } else if (res.action == ACTION_GO_HOME) {
          //home界面收到，则返回界面上
          context.setData({
            scanDialogDisplay: 0,
            dialogShowType: "",//重置类型
          })
        }
      }
    });
  },

  //外接扫码枪事件
  onKeyPress(r) {
    console.log("scan onKeyPress==>" + r);
    if (this.data.scanDialogDisplay != 0) {

      if (this.data.dialogShowType == "refund") {
        refund(r);
      } else {
        this.verifyCoupon(r);
      }
    }
  },

  onHide() {
    // 页面隐藏
    //关闭后屏监听
    my.ix.offBuddyMessage();
  },


  onReady() {
    if (my.canIUse('hideBackHome')) {
      my.hideBackHome();
    }
  },

  //核销券
  verifyCoupon(code) {
    this.setData({ scanDialogDisplay: 2 })
    var commonRequest = {};
    commonRequest.state = 2
    this.sendConvertCouponToBack(commonRequest)
    var couponRequest = api.createCommonRequest();
    couponRequest.couponCode = code;
    console.log("核销券的请求 ==>" + JSON.stringify(couponRequest));
    let context = this;
    my.request({
      url: getApp().globalData.BASE_URL + API_USE_COUPON,
      method: 'POST',
      dataType: 'json',
      timeout: 30000,
      data: couponRequest,
      success: (res) => {
        console.log("核销券成功 ==>" + JSON.stringify(res));
        if (res.data.success != true) {
          var commonRequest = {};
          commonRequest.state = 4
          commonRequest.msg = res.data.errorMsg
          context.sendConvertCouponToBack(commonRequest)
          this.setData({ scanDialogDisplay: 4 })
          console.log("核销券失败 ==>" + res.data.errorMsg);
        } else {
          var commonRequest = {};
          commonRequest.state = 3
          context.sendConvertCouponToBack(commonRequest)
          this.setData({ scanDialogDisplay: 3 })
          console.log("核销券成功 ==>" + JSON.stringify(res));
        }
      },
      fail: (res) => {
        var commonRequest = {};
        commonRequest.state = 4
        commonRequest.msg = "网络异常"
        context.sendConvertCouponToBack(commonRequest)
        this.setData({ scanDialogDisplay: 4 })
        console.log("核销券失败 ==>" + JSON.stringify(res));
        my.showToast({
          type: 'exception',
          content: api.decodeErrorMessage(res.error),
          duration: 2000
        });
      }
    });
  },

  refund(barcode) {
    this.setData({ scanDialogDisplay: 2 })
    var request = api.createCommonRequest();
    request.tradeNo = barcode;

    my.request({
      url: getApp().globalData.BASE_URL + API_REFUND,
      method: 'POST',
      dataType: 'json',
      timeout: 30000,
      data: request,
      success: (res) => {
        if (res.data.success != true || res.data.data == null) {
          this.setData({ scanDialogDisplay: 4 })
          console.log("退款失败 ==>" + JSON.stringify(res.data));
          var message = res.data.message;
          if (message == null) {
            message = "退款失败，请检查退款订单号，稍后再试";
          }
          this.refundCallback(ACTION_REFUND_FAILED, message);
        } else {
          this.setData({ scanDialogDisplay: 3 })
          console.log("退款成功 ==>" + JSON.stringify(res.data));
          this.refundCallback(ACTION_REFUND_SUCCESS, res.data.data);
        }
      },
      fail: (res) => {
        this.setData({ scanDialogDisplay: 4 })
        console.log("退款失败 ==>" + JSON.stringify(res.data));
        var message = res.data.message;
        if (message == null) {
          message = "退款失败，请检查退款订单号，稍后再试";
        }
        this.refundCallback(ACTION_REFUND_FAILED, message);
      }
    });
  },

  refundCallback(action, data) {
    my.ix.sendBuddyMessage({
      // 填入目标小程序的 AppID
      target: getApp().globalData.backScreenAppId,
      data: {
        action: action,
        data: data
      },
      success: (res) => {
        console.info(`sendBuddyMessage success: ${JSON.stringify(res)}`);
        //跳转到扫码页面
      },
      fail: (res) => {
        console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
      }
    });

  },

  //同步兑换券到后台
  sendConvertCouponToBack(e) {
    my.ix.sendBuddyMessage({
      // 填入目标小程序的 AppID
      target: getApp().globalData.backScreenAppId,
      data: {
        action: ACTION_CONVERT_COUPON,
        data: e
      },
      success: (sres) => {
      },
      fail: (fres) => {
        sendConvertCouponToBack(e)
        console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
      }
    });
  }




});
